% this code is from from Emo Todorov's z-iteration algorithm.
function [Z,UUdif] = mdp_zloop(mdp_params,Q,Qend,nsB,NVB,PVB,NX,dv,PX)

itmp = zeros(mdp_params.nx,mdp_params.nv);

eQ = exp(-Q);
eQend = exp(-Qend);

Z{mdp_params.NT} = eQend;

it = 1;
CNT(3) = 0;

% figure(3);
% subplot(1,2,1);
% imagesc(flipud(-log(Z{mdp_params.NT}')));

UUdif = cell(1,mdp_params.NT);

tic;
while it<mdp_params.NT
    Znew = zeros(mdp_params.nx,mdp_params.nv);
    CNT(3) = CNT(3)+1;
    for is=1:nsB
        itmp = mdp_params.nx*(NVB{is} - 1);
        Znew = Znew + PVB{is} .* ...
            (Z{mdp_params.NT-it+1}(NX{1}+itmp).*PX + ...
            Z{mdp_params.NT-it+1}(NX{2}+itmp).*(1-PX));
    end

    Znew = Znew .* eQ;
    
    Z{mdp_params.NT-it} = Znew;
    VV = -log(Z{mdp_params.NT-it});
    
    U = zeros(mdp_params.nx,mdp_params.nv);
    U(:,2:end-1) = (VV(:,1:end-2) - VV(:,3:end))/2/dv;
    U(:,1) = (VV(:,1) - VV(:,2))/dv;
    U(:,end) = (VV(:,end-1) - VV(:,end))/dv;
   
    UUdif{mdp_params.NT-it} = U;
    
%     subplot(1,2,1);
%     imagesc(flipud(VV'));
%     subplot(1,2,2);
%     imagesc(flipud(UUdif{mdp_params.NT-it}'));
%     title(sprintf('%d', it));
%     drawnow;
    
    it = it+1;
end

TM(3) = toc;

fprintf('Z Iteration: %d steps, %.3f sec\n', CNT(3), TM(3));
%}
end
